import {
  useMakeStandardInsertionOrEditingFunction
} from "./chunk-RXV67GJN.mjs";
import {
  useMakeStandardAutosuggestionFunction
} from "./chunk-F6GMWOLE.mjs";
import {
  defaultAutosuggestionsConfig
} from "./chunk-MGYT7RNL.mjs";
import {
  BaseCopilotTextarea
} from "./chunk-PZYM7K4Y.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-MRXNTQOX.mjs";

// src/components/copilot-textarea/copilot-textarea.tsx
import React from "react";
import merge from "lodash.merge";
import { Fragment, jsx } from "react/jsx-runtime";
var CopilotTextarea = React.forwardRef(
  (props, ref) => {
    const _a = props, { autosuggestionsConfig: autosuggestionsConfigUserSpecified } = _a, forwardedProps = __objRest(_a, ["autosuggestionsConfig"]);
    const autosuggestionsConfig = merge(
      defaultAutosuggestionsConfig,
      autosuggestionsConfigUserSpecified
    );
    const autosuggestionsFunction = useMakeStandardAutosuggestionFunction(
      autosuggestionsConfig.textareaPurpose,
      autosuggestionsConfig.contextCategories,
      autosuggestionsConfig.chatApiConfigs.suggestionsApiConfig
    );
    const insertionOrEditingFunction = useMakeStandardInsertionOrEditingFunction(
      autosuggestionsConfig.textareaPurpose,
      autosuggestionsConfig.contextCategories,
      autosuggestionsConfig.chatApiConfigs.insertionApiConfig,
      autosuggestionsConfig.chatApiConfigs.editingApiConfig
    );
    return /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsx(
      BaseCopilotTextarea,
      __spreadProps(__spreadValues({
        ref
      }, forwardedProps), {
        baseAutosuggestionsConfig: __spreadProps(__spreadValues({}, autosuggestionsConfig), {
          apiConfig: {
            insertionOrEditingFunction,
            autosuggestionsFunction
          }
        })
      })
    ) });
  }
);

export {
  CopilotTextarea
};
//# sourceMappingURL=chunk-BNBGJBBM.mjs.map